import java.util.*;
/*
4 2 2
1 2 
1 3
1 2
1 4
5
? 1
F 4 1
? 1
T 4 3
? 1
 */
public class TaskC {
	static Scanner sc = new Scanner(System.in);

	public static void main(String[] args) {
		int n = i();
		int m = i();
		int k = i();
		sc.nextLine(); // skip
		HashMap<Integer, HashSet<Integer>> trips = new HashMap<>();
		boolean[][] friends = new boolean[n][n];
		int a, b;
		for (int i = 0; i < m; i++) {
			a = i();
			b = i();
			friends[a-1][b-1] = friends[b-1][a-1] = true;
			sc.nextLine(); // skip
		}
		for (int i = 0; i < k; i++) {
			addTrainLine(trips, i(), i());
			sc.nextLine();
		}

		int q = Integer.parseInt(sc.nextLine());
		String[] quest;
		while (q-- > 0) {
			quest = sc.nextLine().split(" ");
			if (quest[0].equals("T")) {
				addTrainLine(trips, i(quest[1]), i(quest[2]));
			} else if (quest[0].equals("F")) {
				friends[i(quest[1])-1][i(quest[2])-1] = friends[i(quest[2])-1][i(quest[1])-1] = true;
			} else {
				System.out.println(quest(trips, friends, n, i(quest[1])));
			}
		}
	}

	private static int quest(HashMap<Integer, HashSet<Integer>> trips, boolean[][] friends, int n, int i) {
		int result = 0;
		for (int integer : trips.get(i)) {
			if (friends[i-1][integer-1])
				result++;
		}
		return result;
	}

	private static void addTrainLine(HashMap<Integer, HashSet<Integer>> trips, int a, int b) {
		HashSet<Integer> temp;
		HashSet<Integer> temp2;
		if (!trips.containsKey(a) && !trips.containsKey(b)) {
			temp = new HashSet<>();
			temp.add(b);
			trips.put(a, temp);
			temp = new HashSet<>();
			temp.add(a);
			trips.put(b, temp);
		} else if (!trips.containsKey(a) && trips.containsKey(b)) {
			temp = (HashSet<Integer>) trips.get(b).clone();
			temp.add(b);
			trips.put(a, temp);
			for (Integer integer : temp) {
				trips.get(integer).add(a);
			}
		} else if (!trips.containsKey(b) && trips.containsKey(a)) {
			temp = (HashSet<Integer>) trips.get(a).clone();
			temp.add(a);
			trips.put(b, temp);
			for (Integer integer : temp) {
				trips.get(integer).add(b);
			}
		} else {
			temp = (HashSet<Integer>) trips.get(a).clone();
			temp.add(b);
			temp2 = (HashSet<Integer>) trips.get(b).clone();
			temp2.add(a);
			for (Integer integer : temp) {
				trips.get(integer).addAll(temp2);
			}
			for (Integer integer : temp2) {
				trips.get(integer).addAll(temp);
			}
		}
	}

	private static int i() {
		return sc.nextInt();
	}

	private static int i(String s) {
		return Integer.parseInt(s);
	}
}
