#include <iostream>
#include <vector>
#include <cstring>
#define int long long

using namespace std;

const int MAX_N = 3e5 + 7, M = 1e9 + 7;
int perm[MAX_N], to_pos[MAX_N], f[MAX_N];

void upd(int pos, int c = -1) {
    for (int i = pos; i < MAX_N; i += i & (-i)) f[i] += c;
}

int get(int pos) {
    int res = 0;
    for (int i = pos; i >= 1; i -= i & (-i)) res += f[i];
    return res;
}

void rec(int n, int start, int &pos, int &cnt) {
    if (n == 1) {
        pos = 1;
        cnt = 0;
        return;
    }
    upd(to_pos[n]);
    long long before = get(to_pos[n]);
    if (to_pos[n] < start) {
        before += get(MAX_N - 1) - get(start);
    } else {
        before -= get(start - 1);
    }
    int old_pos, old_cnt;
    rec(n - 1, to_pos[n], old_pos, old_cnt);
    //cout << before << endl;
    //cout << n << ' ' << old_cnt << ' ' << old_pos << ' ' << before << endl;
    pos = old_pos + old_cnt * n + (n - before) - 1;
    pos %= M;
    cnt = old_cnt * n + (n - before) - 1;
    cnt %= M;
}

signed main() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> perm[i];
        to_pos[perm[i]] = i;
        upd(i, 1);
    }
    int pos, lol; 
    rec(n, 1, pos, lol);
    cout << pos << endl;
    return 0;
}
