#pragma GCC optimize("O3")
#include <iostream>
#include <string>
#include <bits/stdc++.h>

#define pb push_back
#define ll long long
#define vi vector<int>
#define vll vector<ll>
#define all(x) x.begin(), x.end()
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define pii pair<int, int>
#define F first
#define S second

using namespace std;

const int maxn = 2e5 + 100;

void init() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    init();
    int n, m;
    cin >> n >> m;
    vll a(n);
    forn(i, n){
        cin >> a[i];
        a[i] %= m;
    }
    int N = 1 << n;
    vi M(N, -1);
    M[0] = 0;
    int dp[N];
    dp[0] = 0;
    for(int mask = 1; mask < N; ++mask){
        int sum;
        forn(i, n){
            if (mask & (1 << i)){
                sum = dp[mask ^ (1 << i)] + a[i];
                break;
            }
        }
        sum %= m;
        if (M[sum] != -1){
            int mask1 = M[sum];
            int mask2 = mask1 & mask;
            mask ^= mask2;
            mask1 ^= mask2;
            vi il, ir;
            forn(i, n){
                if (mask & (1 << i)) il.pb(i);
                if (mask1 & (1 << i)) ir.pb(i);
            }
            cout << il.size() << '\n';
            for (int x : il) cout << x + 1 << ' ';
            cout << '\n' << ir.size() << '\n';
            for (int x : ir) cout << x + 1 << ' ';
            cout << '\n';
            return 0;
        }
        M[sum] = mask;
        dp[mask] = sum;
    }
    cout << "-1\n";
    return 0;
}