#pragma GCC optimize("O3")
#include <iostream>
#include <string>
#include <bits/stdc++.h>

#define pb push_back
#define ll long long
#define vi vector<int>
#define all(x) x.begin(), x.begin()
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define pii pair<int, int>
#define F first
#define S second

using namespace std;

const int maxn = 2e5 + 100;

void init() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    init();
    int n, m;
    cin >> n >> m;
    vi a(n);
    forn(i, n){
        cin >> a[i];
        a[i] %= m;
    }
    if (n == 1){
        if (a[0] == 0){
            cout << 1 << '\n' << 1 << '\n' << 0 << '\n' << '\n';
        } else {
            cout << "-1\n";
        }
        return 0;
    }
    int n1 = n / 2, n2 = n - n1;
    int pow[15];
    pow[0] = 1;
    for (int i = 1; i < 15; ++i) pow[i] = 3 * pow[i - 1];
    vi a1, a2;
    forn(i, n){
        if (i < n1) a1.pb(a[i]); else a2.pb(a[i]);
    }
    map<int, pii> map1, map2;
    vi sums;
    forn(i, pow[n1]){
        int j = i;
        int sum = 0;
        int mask1 = 0, mask2 = 0;
        int i1 = 0;
        while (j > 0){
            if (j % 3 == 1){
                mask1 |= (1 << i1);
                sum += a1[i1];
            }
            if (j % 3 == 2){
                mask2 |= (1 << i1);
                sum -= a1[i1];
            }
            i1++;
            j /= 3;
        }
        sum %= m;
        if (sum < 0) sum += m;
        if (map1.count(sum)) continue;
        map1[sum] = {mask1, mask2};
        sums.pb(sum);
    }
    set<int> sums2;
    for(int i = 1; i < pow[n2]; ++i){
        int j = i;
        int sum = 0;
        int mask1 = 0, mask2 = 0;
        int i1 = 0;
        while (j > 0){
            if (j % 3 == 1){
                mask1 |= (1 << i1);
                sum += a2[i1];
            }
            if (j % 3 == 2){
                mask2 |= (1 << i1);
                sum -= a2[i1];
            }
            i1++;
            j /= 3;
        }
        //cout << i << ' ' << sum << '\n';
        sum %= m;
        if (sum < 0) sum += m;
        if (map2.count(sum)) continue;
        map2[sum] = {mask1, mask2};
        sums2.insert(sum);
    }
    for (int sum1 : sums){
        int sum2 = (m - sum1) % m;
        if (!sums2.count(sum2)) continue;
        vi il, ir;
        int mask11 = map1[sum1].F, mask12 = map1[sum1].S;
        int mask21 = map2[sum2].F, mask22 = map2[sum2].S;
        forn(i, n){
            int I = 1 << i;
            if (I & mask11) il.pb(i);
            if (I & mask12) ir.pb(i);
            I = 1 << (i - n1);
            if (I & mask21) il.pb(i);
            if (I & mask22) ir.pb(i);
        }
        cout << il.size() << '\n';
        for (int x : il) cout << x + 1 << ' ';
        cout << '\n' << ir.size() << '\n';
        for (int x : ir) cout << x + 1 << ' ';
        cout << '\n';
        return 0;
    }
    cout << "-1\n";
    return 0;
}


