#include <bits/stdc++.h>
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); i++) 

using namespace std;

typedef long long ll;

const int B = 300;

const int N = 300000;

int dsu[N];
int vis[N];
int sz[N];

int tt = 1;

int get(int v) {
	if (vis[v] != tt) {
		vis[v] = tt;
		dsu[v] = v;
		sz[v] = 1;
	}
	if (v == dsu[v]) {
		return v;
	} else {
		return dsu[v] = get(dsu[v]);
	}
}

int ptr = 0;

void reset_graph() {
	tt++;
}

bool bad = false;

void uni(int u, int v) {
	u = get(u), v = get(v);
	if (u == v) {
		bad = true;
	}
	if (sz[u] > sz[v]) {
		swap(u, v);
	}
	dsu[u] = v;
	sz[v] += sz[u];
}

int ok[N];
int mda[N];

vector <int> g[N];

int comp_id(int v) {
	v = get(v);
	if (ok[v] == tt) {
		return mda[v];
	} else {
		ok[v] = tt;
		g[ptr].clear();
		mda[v] = ptr++;
		return mda[v];
	}
}

vector <pair <int, int> > st;

bool visited[N];

mt19937 rnd(228);

int main() {
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	int n = 300000;
	//cin >> n;
	vector <int> a(n);
	vector <int> b;
	for (int i = 0; i < n; i++) {
		a[i] = rnd() % n + 1;
		//cin >> a[i];
		b.push_back(a[i]);
	}
	auto value = a;
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	for (int i = 0; i < n; i++) {
		a[i] = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
	}
	vector <int> ok(n + 2);
	for (int chet = 0; chet < 2; chet++) {
		vector <pair <int, int> > edges;
		for (int i = chet; i + 1 < n; i += 2) {
			edges.push_back({a[i], a[i + 1]});
		}
		int bl = -1, br = -1;
		int its = 0;
		auto recalc = [&] (int l, int r) {
			if (l / B != bl || r / B != br) {
				bad = false;
				bl = l / B, br = r / B;
				reset_graph();
				its++;
		//		cout << its << ' ' << l << ' ' << r << endl;
				for (int i = (bl + 1) * B; i < br * B; i++) {
					if (bad) break;
					uni(edges[i].first, edges[i].second);
				}
			}
		};
		auto check = [&] (int l, int r) {
			if (bad) {
				return false;
			}
			recalc(l, r);
			tt++;
			ptr = 0;
			st.clear();
			if (l / B == r / B) {
				for (int i = l; i <= r; i++) {
					st.push_back({comp_id(edges[i].first), comp_id(edges[i].second)});
				}
			} else {
				for (int i = l; i < (bl + 1) * B; i++) {
					st.push_back({comp_id(edges[i].first), comp_id(edges[i].second)});
				}
				for (int i = br * B; i <= r; i++) {
					st.push_back({comp_id(edges[i].first), comp_id(edges[i].second)});
				}
			}
			for (int i = 0; i < ptr; i++) {
				visited[i] = 0;
			}
			for (auto c : st) {
				g[c.first].push_back(c.second);
				g[c.second].push_back(c.first);
			}
			int comps = 0;
			int edges = st.size();
			for (int i = 0; i < ptr; i++) {
				if (!visited[i]) {
					comps++;
					queue <int> q;
					q.push(i);
					while (!q.empty()) {
						int v = q.front();
						q.pop();
						for (int to : g[v]) {
							if (!visited[to]) {
								visited[to] = true;
								q.push(to);
							}
						}
					}
				}
			}
			return edges == ptr - comps;
		};
		int j = -1;
		for (int i = 0; i < (int) edges.size(); i++) {
			j = max(j, i - 1);
			while (j + 1 < (int) edges.size() && check(i, j + 1)) {
				j++;
			}
			ok[2 * i + chet] = 2 * j + chet + 1;
		}
	}
	ll ans = 0;
	vector <int> dp(n + 1);
	for (int i = n - 1; i >= 0; i--) {
		if (value[i] == 0 || ok[i + 1] >= i + 2 * value[i]) {
			dp[i] = dp[i + 2 * value[i] + 1] + 1;
		} else {
			dp[i] = 0;
		}
		ans += dp[i];
	}
	cout << ans << endl;
}
