//package olymp;

import java.util.Comparator;
import java.util.LinkedList;
import java.util.Scanner;

public class B {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);

        int n = sc.nextInt();
        int m = sc.nextInt();
        int s = sc.nextInt();

        LinkedList<three> pay = new LinkedList<three>();
        for (int i = 0; i < n; i++)
            pay.add(new three(sc.nextInt(), sc.nextInt(), sc.nextInt()));

        pay.sort(new Comparator<three>() {
            @Override
            public int compare(three a, three b) {
                int f, s;
                f = (a.count < 0) ? a.from : a.to;
                s = (b.count < 0) ? b.from : b.to;

                if (f == s) {
                    if (a.count < 0 && b.count >= 0) return 1;
                    if (a.count >= 0 && b.count < 0) return -1;
                }

                return Integer.compare(s, f);
            }
        });

        LinkedList<three> npay = new LinkedList<>();
        for (B.three three : pay) npay.addFirst(three);
        pay = npay;

        for (int i = 0; i < pay.size(); i++) {
            s += pay.get(i).count;

            if (s < 0) {

                System.out.println("YES");
                System.exit(0);
            }
        }

        System.out.println("NO");
    }

    static class three {
        int count, from, to;

        public three(int count, int from, int to) {
            this.count = count;
            this.from = from;
            this.to = to;
        }

        @Override
        public String toString() {
            return "three{" +
                    "count=" + count +
                    ", from=" + from +
                    ", to=" + to +
                    '}';
        }
    }
}
