#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <unordered_set>
#include <conio.h>
#define UNDEF -1;

using namespace std;


typedef long long int ll;

struct edge {
	int u;
	int v;
	int cost;
	edge(int a, int b, int c) {
		u = a;
		v = b;
		cost = c;
	}
};

struct event {
	int x;
	int type;
	int num;
	event(int x, int type, int num) : x(x), type(type), num(num) {}
};

struct triple {
	int first;
	int second;
	int third;
	triple(int a, int b, int c) {
		first = a;
		second = b;
		third = c;
	}
};

int main() {
	int n, m;
	cin >> n;
	string right;
	cin >> right;
	cin >> m;
	vector<string> v;
	for (int i = 0; i < m; i++) {
		string s;
		cin >> s;
		v.push_back(s);
	}

	vector<vector<int>> ans(m, vector<int>(m, -1));
	int count = 0;
	vector<pair<int, int>> w;
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < m; j++) {
			if (j == i) continue;
			int BothWrong = 0, BothTrue = 0, Wrong1 = 0, Wrong2 = 0, True1 = 0, True2 = 0;
			for (int k = 0; k < n; k++) {
				if (v[i][k] == right[k] && v[j][k] == right[k]) {
					BothTrue++;
					True1++;
				}
				else if (v[i][k] == v[j][k] && v[i][k] != right[k]) {
					BothWrong++;
					True2++;
				}
				else if (v[i][k] == right[k]) {
					True1++;
				}
				else if (v[j][k] == right[k])
					True2++;
				if (v[i][k] != right[k])
					Wrong1++;
				if (v[j][k] != right[k])
					Wrong2++;
			}

			for (int k = 0; k < n; k++) {
				if (v[i] == v[j]) {
					ans[i][j] = 1;
					if (ans[i][j] == ans[j][i]) {
						count++;
						w.push_back(make_pair(i + 1, j + 1));
					}
				}
				else
				if (Wrong1 == Wrong2 && Wrong1 == m) {
					ans[i][j] = 1;
					if (ans[i][j] == ans[j][i]) {
						count++;
						w.push_back(make_pair(i + 1, j + 1));
					}
				}
				else
				if (True1 / 2 > BothTrue && Wrong1 / 2 > BothWrong) {
					ans[i][j] = 1;
					if (ans[i][j] == ans[j][i]) {
						count++;
						w.push_back(make_pair(i + 1, j + 1));
					}
				}
			}
		}
	}
	cout << count / n << endl;
	for (int i = 0; i < w.size(); i += n) {
		cout << w[i].first << " " << w[i].second << endl;
	}
	return 0;
}


