#include <iostream>
#include <bitset>
#include <vector>
#include <cstring>

using namespace std;

int a[30];
char cs[40000007];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    memset(cs, -1, sizeof(char) * 40000007);

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        x %= m;
        a[i] = x;
    }
    int res_mod = -1;
    int mask1 = -1;
    int mask2 = -1;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int cur = 0;
        int tmp = mask;
        for (int i = 0; i < n; ++i) {
            if (tmp & 1) {
                cur += a[i];
                cur %= m;
            }
            tmp >>= 1;
            if (tmp == 0) {
                break;
            }
        }
        if (cs[cur] != -1) {
            res_mod = cur;
            mask1 = mask;
            mask2 = cs[cur];
            break;
        }
        cs[cur] = mask;
    }
    if (res_mod == -1) {
        cout << -1;
        return 0;
    }

    cout << __builtin_popcount(mask1) << '\n';

    for (int i = 0; i < n; ++i) {
        if (mask1 & 1) {
            cout << i + 1 << ' ';
        }
        mask1 >>= 1;
    }
    cout << '\n';

    cout << __builtin_popcount(mask2) << '\n';

    for (int i = 0; i < n; ++i) {
        if (mask2 & 1) {
            cout << i + 1 << ' ';
        }
        mask2 >>= 1;
    }
    cout << '\n';
}
