import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class B {
    static BufferedReader bf;
    static StringTokenizer in;
    public static String nextToken() throws IOException {
        while(in==null||!in.hasMoreTokens()){
            in = new StringTokenizer(bf.readLine());
        }
        return  in.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static void main(String[] args) throws IOException {
        bf = new BufferedReader(new InputStreamReader(System.in));
        int n = nextInt(), m=nextInt(), s=nextInt();

        long[] res = new long[m];
        for (int i = 0; i < m; i++) {
            res[i] = 0;
        }
        for (int i = 0; i < n; i++) {
            int count=nextInt(), from=nextInt(), to=nextInt();
            if (count < 0) {
                for (int j = from - 1; j < m; j++) {
                    res[j] += count;
                }
            }
            else {
                for (int j = to; j < m; j++) {
                    res[j] += count;
                }
            }
        }
        long min = res[0];
        for (int i = 1; i < m; i++) {
            if (res[i] < min) {
                min = res[i];
            }
        }
        if (s + min < 0) {
            System.out.println("YES");
        }
        else {
            System.out.println("NO");
        }
    }
}
