import java.util.*;
import java.io.*;
public class Main {
    public static void main(String[] args) throws IOException {
        BufferedReader rd = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter pw = new PrintWriter(System.out);
        int n = Integer.parseInt(rd.readLine());
        int[][] arr = new int[n][3];
        int[][] occ = new int[n][3];
        int[] pos = new int[n];
        for (int i = 0; i < n; i++) {
            String[] s = rd.readLine().split(" ");
            int a = Integer.parseInt(s[0]) - 1;
            int b = Integer.parseInt(s[1]) - 1;
            int c = Integer.parseInt(s[2]) - 1;
            arr[i] = new int[]{a, b, c};
            occ[a][pos[a]++] = i;
            occ[b][pos[b]++] = i;
            occ[c][pos[c]++] = i;
        }
        int[][] neighbor = new int[n][2];
        for (int i = 0; i < n; i++) {
            int now = 0;
            TreeSet<Integer> set = new TreeSet<>();
            for (int j = 0; j < 3; j++) {
                for (int k = 0; k < 3; k++) {
                    int x = arr[occ[i][j]][k];
                    if (x == i) continue;
                    if (set.contains(x) && now != 2) {
                        neighbor[i][now++] = x;
                    }
                    set.add(x);
                }
            }
        }
        pw.print((neighbor[0][0] + 1) + " " + 1 + " " + (neighbor[0][1] + 1) + " ");
        int cnt = 3;
        int prev = 0;
        int last = neighbor[0][1];
        while (cnt < n) {
            int[] list = neighbor[last];
            if (list[0] == prev) {
                pw.print((list[1] + 1) + " ");
                prev = last;
                last = list[1];
            } else {
                pw.print((list[0] + 1) + " ");
                prev = last;
                last = list[0];
            }
            cnt++;
        }
        pw.println();
        pw.flush();
    }
}
