#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>

#define int long long

using namespace std;

int32_t main() {
#ifdef local
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<vector<int>> g(n);
    set<vector<int>> mp;
    for (int i = 0; i < n; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        vector<int> p = {x - 1, y - 1, z - 1};
        sort(p.begin(), p.end());
        mp.insert(p);
        g[x - 1].push_back(y - 1);
        g[x - 1].push_back(z - 1);
        g[y - 1].push_back(x - 1);
        g[y - 1].push_back(z - 1);
        g[z - 1].push_back(y - 1);
        g[z - 1].push_back(x - 1);
    }
    if (n == 3) {
        cout << "1 2 3";
        return 0;
    }
    if (n == 4) {
        for (int i = 0; i < n; i++) {
            set<int> s(g[i].begin(), g[i].end());
            g[i].clear();
            for (int to : s) {
                g[i].push_back(to);
                //cout << to + 1 <<  ' ';
            }
            //cout << endl;
        }
        for (int f = 0; f < 23; f++) {
            vector<int> t = {0, 1, 2, 3};
            vector<int> ans = t;
            int fl = 1;
            for (int i = 0; i < n; i++) {
                vector<int> w = {ans[i], ans[(i + 1) % n], ans[(i + 2) % n]};
                sort(w.begin(), w.end());
                if (!mp.count(w)) {
                    fl = 0;
                    break;
                }
            }
            if (fl) {
                for (int i : ans) {
                    cout << i + 1 << ' ';
                }
                return 0;
            }
            next_permutation(t.begin(), t.end());
        }
        return 0;
    }
    vector<int> t = {0, 1, 2, 3};
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        set<int> s(g[i].begin(), g[i].end());
        g[i].clear();
        for (int to : s) {
            g[i].push_back(to);
            //cout << to + 1 <<  ' ';
        }
        //cout << endl;
    }
    for (int f = 0; f < 23; f++) {
        ans.clear();
        ans.resize(n);
        ans[0] = g[0][t[0]];
        ans[1] = g[0][t[1]];
        ans[2] = 0;
        ans[3] = g[0][t[2]];
        ans[4] = g[0][t[3]];
        vector<int> used(n);
        for (int i = 0; i < 5; i++) {
            used[ans[i]] = 1;
        }
        for (int i = 5; i < n; i++) {
            for (int j : g[ans[i - 2]]) {
                if (!used[j]) {
                    ans[i] = j;
                    used[j] = 1;
                }
            }
        }
        int fl = 1;
        for (int i = 0; i < n; i++) {
            vector<int> w = {ans[i], ans[(i + 1) % n], ans[(i + 2) % n]};
            sort(w.begin(), w.end());
            /*cout << ' ';
            for (int to : t) cout << to + 1 << ' ';
            cout << endl;
            cout << ' ';
            for (int to : pos) cout << to + 1 << ' ';
            cout << endl;*/
            if (!mp.count(w)) {
                fl = 0;
                break;
            }
        }
        if (fl) {
            for (int i : ans) {
                cout << i + 1 << ' ';
            }
            return 0;
        }
        //cout << endl;
        next_permutation(t.begin(), t.end());
    }
    return 0;
}
