/**
 *    author:  tourist
 *    created: 23.10.2019 22:31:30       
**/
#include <bits/stdc++.h>

using namespace std;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  vector<int> sum(1 << n);
  for (int t = 0; t < (1 << n); t++) {
    for (int i = 0; i < n; i++) {
      if (t & (1 << i)) {
        sum[t] += a[i];
      }
    }
  }
  const int inf = (int) 1e9;
  vector<vector<int>> dp(1 << n, vector<int>(181, inf));
  vector<vector<int>> pi(1 << n, vector<int>(181, -1));
  vector<vector<int>> px(1 << n, vector<int>(181, -1));
  dp[0][0] = 1;
  for (int t = 0; t < (1 << n); t++) {
    for (int x = 0; x <= 180; x++) {
      if (dp[t][x] == inf) {
        continue;
      }
      int y = sum[t] - x;
      for (int i = 0; i < n; i++) {
        if ((t & (1 << i)) || x + a[i] > 180) {
          continue;
        }
        int ft = dp[t][x];
        if (x + a[i] != 180 && x + a[i] != y) {
          ft += 1;
        }
        int nx = min(x + a[i], y);
        if (ft < dp[t | (1 << i)][nx]) {
          dp[t | (1 << i)][nx] = ft;
          pi[t | (1 << i)][nx] = i;
          px[t | (1 << i)][nx] = x;
        }
      }
    }
  }
  vector<pair<int, int>> ret;
  int acc = 0;
  for (int i = 0; i < n; i++) {
    ret.emplace_back(acc, 0);
    acc += a[i];
  }
  if (acc < 360) {
    ret.emplace_back(acc, 0);
  }
  for (int fx = 0; fx <= 180; fx++) {
    int t = (1 << n) - 1;
    if (dp[t][fx] < (int) ret.size()) {
      vector<bool> cut(361, false);
      cut[0] = cut[180] = true;
      int flag = 0;
      int x = fx;
      while (t > 0) {
        int i = pi[t][x];
        int nx = x;
        x = px[t][x];
        if (x + a[i] != nx) {
          flag ^= 1;
        }
        cut[flag * 180 + x + a[i]] = true;
        t ^= (1 << i);
      }
      ret.clear();
      for (int i = 0; i < 180; i++) {
        if (cut[i] && cut[i + 180]) {
          ret.emplace_back(i, 1);
        }
        if (cut[i] && !cut[i + 180]) {
          ret.emplace_back(i, 0);
        }
        if (!cut[i] && cut[i + 180]) {
          ret.emplace_back(i + 180, 0);
        }
      }
      assert(dp[(1 << n) - 1][fx] == (int) ret.size());
    }
  }
  cout << ret.size() << '\n';
  for (auto& p : ret) {
    cout << p.first << " " << p.second << '\n';
  }
  return 0;
}
