import java.util.*;

public class TaskI {

	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		Triplet t;
		Triplet[] with1 = new Triplet[3];
		ArrayList<Triplet> triplets = new ArrayList<>();
		for (int j = 0, i = 0; j < n; j++) {
			t = new Triplet(sc.nextInt(), sc.nextInt(), sc.nextInt());
			if (t.contains(1))
				with1[i++] = t;
			triplets.add(t);
		}

		int[] result = new int[n];
		result[0] = 1;
		result[1] = find(with1);
		Triplet tr;
		for (int i = 2; i < n; i++) {
			for (int j = 0; j < triplets.size(); j++) {
				tr = triplets.get(j);
				if (tr.contains(result[i - 1], result[i - 2])) {
					result[i] = tr.a + tr.b + tr.c - result[i - 1] - result[i - 2];
					triplets.remove(tr);
					break;
				}
			}
		}
		for (int i : result) {
			System.out.print(i + " ");
		}
		System.out.println();
	}

	private static int find(Triplet[] with1) {
		HashSet<Integer> set = new HashSet<>();
		set.add(with1[0].a);
		set.add(with1[0].b);
		set.add(with1[0].c);
		set.add(with1[1].a);
		set.add(with1[1].b);
		set.add(with1[1].c);
		set.add(with1[2].a);
		set.add(with1[2].b);
		set.add(with1[2].c);
		set.remove(1);
		for (Integer i : set) {
			if ((with1[0].contains(i) && with1[1].contains(i)) || (with1[0].contains(i) && with1[2].contains(i))
					|| (with1[1].contains(i) && with1[2].contains(i)))
				return i;
		}
		return 0;
	}

	private static class Triplet {
		public final int a, b, c;

		public Triplet(int a, int b, int c) {
			this.a = a;
			this.b = b;
			this.c = c;
		}

		public boolean contains(int i) {
			return a == i || b == i || c == i;
		}

		public boolean contains(int i, int j) {
			if (i != j)
				return contains(i) && contains(j);
			return (a == i && b == i) || (a == i && c == i) || (b == i || c == i);
		}

		@Override
		public String toString() {
			return "T[" + a + ", " + b + ", " + c + "]";
		}

	}
}
