#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

const int l = 100;

template <class T = int>
T next() { T x; cin >> x; return x; }

int main()
{
	int n;
	cin >> n;
	string orig;
	cin >> orig;
	int m;
	cin >> m;
	string s[l];
	for (int i = 0; i < m; i++) cin >> s[i];

	vector <pair <int, int>> ans;
	
	for (int i = 0; i < m; i++)
	{
		for (int j = i + 1; j < m; j++)
		{
			int right = 0, wrong = 0;
			int t_right1 = 0, t_wrong1 = 0, t_right2 = 0, t_wrong2 = 0;
			for (int k = 0; k < n; k++)
			{
				if (s[i][k] == s[j][k])
				{
					if (s[i][k] == orig[k]) right++;
					else wrong++;
				}
				if (s[i][k] == orig[k]) t_right1++;
				else t_wrong1++;
				if (s[j][k] == orig[k]) t_right2++;
				else t_wrong2++;
			}
			bool one = wrong * 2 > t_wrong1 && right * 2 > t_right1;
			bool two = wrong * 2 > t_wrong2 && right * 2 > t_right2;
			if (two && one)
				ans.push_back({ i + 1, j + 1 });
		}
	}

	cout << ans.size() << '\n';
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i].first << ' ' << ans[i].second << '\n';
}