#include <iostream>
#include <vector>



#define pb push_back
using namespace std;

typedef long long ll;

ll next(){ll x; cin >> x; return x;}

const ll inf = 2e18;



inline int mn(int a , int b , int m){
    a -= b;
    if (a < 0) a += m;
    return a;
}

inline int pl(int a , int b , int m){
    a += b;
    if (a >= m) a -= m;
    return a;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n = next() , m = next();
    vector <int> s(m+1);
    int a[26];
    s[0] = 0;
    int siz = 1;
    vector<int> last(m , -1);
    vector <bool> lst(m);
    bool zero = false;

    for (int i = 0; i < n; ++i){
        int x; cin >> x; x %= m;
        a[i] = x;
        int sz = siz;
        for (int j = 0; j < sz; ++j){
            int cur1 = pl(s[j] , x , m);

            if (last[cur1] == -1) {
                last[cur1] = i;
                lst[cur1] = true;
                s[siz++] = cur1;
            }

            int cur2 = mn(s[j] , x , m);


            if (last[cur2] == -1){
                last[cur2] = i;
                lst[cur2] = false;
                s[siz++] = cur2;
            }

            zero = (zero || (cur1 == 0 || cur2 == 0));
        }
    }

    if (!zero){
        cout << "-1";
        return 0;
    }

    int cur = last[0];
    int cur_sum = 0;
    vector <int> ans1 , ans2;
    int cnt = 0;
    while(true){
        if (lst[cur_sum]){
            cur_sum = mn(cur_sum , a[cur] , m);
            ans1.pb(cur + 1);
        } else {
            cur_sum = pl(cur_sum , a[cur] , m);
            ans2.pb(cur + 1);
        }
        if (cur_sum == 0) break;
        cnt++;
        if (cnt > n + 2){
            cout << "-1";
            return 0;
        }

        cur = last[cur_sum];
    }

    cout << ans1.size() << '\n';
    for (auto t : ans1) cout << t << ' ';
    if (ans1.size() != 0) cout << '\n';
    cout << ans2.size() << '\n';
    for (auto t : ans2) cout << t << ' ';

    return 0;
}
/*
4 1
2 3 4 5


4 14
1 3 7 10

3 7
1 2 4

*/
