#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <unordered_set>
#include <conio.h>
#define UNDEF -1;

using namespace std;


typedef long long int ll;

struct edge {
	int u;
	int v;
	int cost;
	edge(int a, int b, int c) {
		u = a;
		v = b;
		cost = c;
	}
};

struct event {
	int x;
	int type;
	int num;
	event(int x, int type, int num) : x(x), type(type), num(num) {}
};

int main() {
	int n, m;
	string right;
	cin >> n;
	cin >> right;
	cin >> m;
	vector<string> v(m);
	for (int i = 0; i < m; i++)
		cin >> v[i];
	int count = 0;
	vector<pair<int, int>> ans;
	for (int i = 0; i < m; i++) {
		for (int j = i + 1; j < m; j++) {
			vector<int> good(2, 0), bad(2, 0);
			for (int k = 0; k < n; k++) {
				if (v[i][k] == right[k]) {
					good[0]++;
				}
				else bad[0]++;
				if (v[j][k] == right[k])
					good[1]++;
				else bad[1]++;
			}
			int countGOOD = 0, countBAD = 0;
			for (int k = 0; k < n; k++) {
				if (v[i][k] == v[j][k] && v[i][k] == right[k])
					countGOOD++;
				else if (v[i][k] == v[j][k] && v[i][k] != right[k])
					countBAD++;
			}
			if (countGOOD > good[0] / 2 && countBAD > bad[0] / 2 || (countGOOD > good[0] / 2 && bad[0] == 0 && bad[1] == 0) || (countBAD > bad[0] / 2 && good[0] == 0 && good[1] == 0)) {
				count++;
				ans.push_back(make_pair(i + 1, j + 1));
			}
		}
	}
	cout << count << endl;
	for (auto i : ans) {
		cout << i.first << " " << i.second << endl;
	}
	return 0;
}

/*cin >> n >> m >> s;
int a = 0, b = 0, c = 0;
vector <vector <int>> v(n);
for (int i = 0; i < n; i++) {
	cin >> a >> b >> c;
	if (a < 0) {

	}
}*/
