#define _CRT_SECURE_NO_WARNINGS

#include <vector>
#include <queue>
#include <stdlib.h>

using namespace std;

int main(void)
{
	int n, m, k;
	vector<vector<char>> M;

	scanf("%i %i %i", &n, &m, &k);
	getchar();
	M.resize(n);
	for (int i = 0; i < n; i++)
		M[i].resize(n);
	for (int i = 0; i < m; i++)
	{
		int a, b;
		scanf("%i %i", &a, &b);
		getchar();
		M[a-1][b-1] += 2;
		M[b-1][a-1] += 2;
	}
	for (int i = 0; i < k; i++)
	{
		int a, b;
		scanf("%i %i", &a, &b);
		getchar();
		M[a-1][b-1] += 1;
		M[b-1][a-1] += 1;
	}
	int qa;
	scanf("%i", &qa);
	queue<int> q;
	bool* used = new bool[n];
	memset(used, 0, sizeof(bool) * n);
	getchar();
	while (qa--)
	{
		int a = 0, b = 0;
		switch (getchar())
		{
		case 'T':
			scanf("%i %i", &a, &b);
			getchar();
			M[a-1][b-1] += 1;
			M[b-1][a-1] += 1;
			break;
		case 'F':
			scanf("%i %i", &a, &b);
			getchar();
			M[a-1][b-1] += 2;
			M[b-1][a-1] += 2;
			break;
		case '?':
			scanf("%i", &a);
			getchar();
			q.push(a - 1);
			used[a - 1] = true;

			while (!q.empty())
			{
				int v = q.front();
				q.pop();
				for (int i = 0; i < n; i++)
				{
					int to = M[v][i];
					if (!used[i] && (to & 1))
					{
						used[i] = true;
						q.push(i);
					}
				}
			}
			for (int i = 0; i < n; i++)
				b += used[i] * ((M[a-1][i] & 2) != 0);
			memset(used, 0, sizeof(bool) * n);
		    printf("%i\n", b);
			break;
		}
	}
	delete[] used;
}