#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <vector>

using namespace std;

int main( void )
{
  int n, m, s;
  vector<pair<int, int>> T;

  scanf("%i %i %i", &n, &m, &s);

  for (int i = 0; i < n; i++)
  {
    int cnt, d1, d2;
    scanf("%i %i %i", &cnt, &d1, &d2);
    if (cnt < 0)
      T.push_back(pair<int, int>(cnt, d1));
    if (cnt > 0)
      T.push_back(pair<int, int>(cnt, d2));
  }

  qsort(T.data(), T.size(), sizeof(pair<int, int>), [](const void *A, const void *B) -> int
    {
      int a1 = ((pair<int, int>*)A)->first, a2 = ((pair<int, int>*)B)->first, 
        b1 = ((pair<int, int>*)A)->second, b2 = ((pair<int, int>*)B)->second;

      if (b1 - b2)
        return (b1 > b2) * 2 - 1;
      if (a1 - a2)
        return (a1 > a2) * 2 - 1;
      return 0;
    });

  for (auto p : T)
  {
    s += p.first;
    if (s < 0)
    {
      printf("YES");
      return 0;
    }
  }
  printf("NO");
  return 0;
}