#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 100005;

int parent[N], siz[N];
pair <int, set <int> > fr[N];
int prevz[N];

void build(int v)
{
    parent[v] = v;
    siz[v] = 1;
    return;
}

int find_num(int v)
{
    if (parent[v] == v)
        return v;
    return parent[v] = find_num(parent[v]);
}

void update(int v, int u)
{
    v = find_num(v);
    u = find_num(u);
    if (siz[v] < siz[u])
    {
        parent[v] = parent[u];
        siz[u] += siz[v];
    } else {
        parent[u] = parent[v];
        siz[v] += siz[u];
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);

    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++)
        build(i);
    int x, y;
    for (int i = 0; i < m; i++)
    {
        cin >> x >> y;
        x--;
        y--;
        fr[x].second.insert(y);
        fr[y].second.insert(x);
    }
    for (int i = 0; i < k; i++)
    {
        cin >> x >> y;
        x--;
        y--;
        update(x, y);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        char w;
        cin >> w;
        if (w == '?')
        {
            cin >> x;
            x--;
            for (int j: fr[x].second)
            {
                if (fr[x].second.count(j) == 0)
                    break;
                if (find_num(j) == find_num(x))
                {
                    fr[x].first++;
                    fr[x].second.erase(j);
                }
            }
            cout << fr[x].first << endl;
        }
        if (w == 'F')
        {
            cin >> x >> y;
            x--;
            y--;
            fr[x].second.insert(y);
            fr[y].second.insert(x);
        }
        if (w == 'T')
        {
            cin >> x >> y;
            x--;
            y--;
            update(x, y);
        }
    }
    return 0;
}
