#include <bits/stdc++.h>

#pragma GCC optimize("O3")

#ifdef DEBUG
#define io freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout)
#else
#define io ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr)
#endif

#define forn(i, n) for (ll i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()

using namespace std;

typedef long long ll;
typedef long double ld;

class treap {
    struct Node {
        ll x, y = (rand() << 16) + rand();
        Node *left = nullptr, *right = nullptr;
        Node(ll x) {
            this->x = x;
        }
    };

    Node* merge(Node *left, Node *right) {
        if (left == nullptr) return right;
        if (right == nullptr) return left;
        if (left->y < right->y) {
            right->left = merge(left, right->left);
        } else left->right = merge(left->right, right);
    }
};

int main() {
    io;
    ll n;
    cin >> n;
    deque<ll> a(n);
    vector<ll> pos(n + 1);
    for(ll i = 0; i < n; i++) {
        cin >> a[i];
        pos[a[i]] = i;
    }
    vector<ll> ans;
    ll s = 0;
    for(ll i = n; i > 1; i--) {
        ll cnt = i - 1 - (pos[i] + s) % i;
        ans.push_back(cnt);
        s += cnt;
        if(pos[i - 1] > pos[i]) s = (s + i - 1) % i;
    }
    ll aa = 1, mult = 1;
    for(ll i: ans) {
        aa += mult * i;
        if(aa >= (ll)(1e9 + 7))
            aa = aa  % (ll)(1e9 + 7);
        mult = mult * n + 1;
        if(mult >= (ll)(1e9 + 7))
            mult %= (ll)(1e9 + 7);
        n--;
    }
    cout << aa % (ll)(1e9 + 7);
}