from sys import setrecursionlimit
import threading

setrecursionlimit(10 ** 9)
threading.stack_size(67108864)

def findRoads(cityId, cityToFind, roads):
    if cityId == cityToFind:
        return True
    for road in roads:
        if road[0] == cityId:
            return findRoads(road[1], cityToFind, roads)
        if road[1] == cityId:
            return findRoads(road[0], cityToFind, roads)

def main():
    inp = input().split(" ")
    n, m, k = int(inp[0]), int(inp[1]), int(inp[2])
    friends = []
    roads = []
    for i in range(m):
        inp = input().split(" ")
        friends.append([int(inp[0]), int(inp[1])])
    for i in range(k):
        inp = input().split(" ")
        roads.append([int(inp[0]), int(inp[1])])
    q = int(input())

    for i in range(q):
        inp = input()
        sInp = inp.split(" ")
        if inp[0] == "F":
            friends.append([int(sInp[1]), int(sInp[2])])
        elif inp[0] == "T":
            roads.append([int(sInp[1]), int(sInp[2])])
        else:
            connected = 0
            for friendPair in friends:
                if friendPair[0] == int(sInp[1]):
                    if findRoads(friendPair[1], int(sInp[1]), roads):
                        connected += 1
                else:
                    if findRoads(friendPair[0], int(sInp[1]), roads):
                        connected += 1
            print(connected)

thread = threading.Thread(target=main)
thread.start()