#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>

using namespace std;

int n, m;
int id[40000000], used[40000000], a[25];
void solve(int B, int s) {
    if (used[2 * s - m]) {
        //cout << id[2 * s % m] << endl;
        set<int> ans1, ans2;
        for (int i = 0; i < n; i++) {
            if ((1 << i) & B) {
                ans1.insert(i + 1);
            }
        }
        for (int i = 0; i < n; i++) {
            if ((1 << i) & id[2 * s % m]) {
                if (!ans1.count(i + 1))
                    ans2.insert(i + 1);
            }
        }
        cout << ans1.size() << '\n';
        for (int i : ans1) {
            cout << i << ' ';
        }
        cout << '\n';
        cout << ans2.size() << '\n';
        for (int i : ans2) {
            cout << i << ' ';
        }
       exit(0);
    }
    if (B == 0) return;
    used[s] = 1;
    id[s] = B;
    for (int i = 0; i < n; i++) {
        if (B & (1 << i)) {
            solve(B - (1 << i), s - a[i] < 0 ? s - a[i] + m : s - a[i]);
        }
    }
    used[s] = 0;
    id[s] = 0;
}

int32_t main() {
#ifdef local
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    int s = 0;
    for (int i = 0; i < n; i++) cin >> a[i], a[i] %= m, s += a[i];
    solve((1 << n) - 1, s % m);
    cout << -1;
    return 0;
}
