#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt,tune=native")
#pragma GCC target("avx,avx2")

#include "bits/stdc++.h"

typedef long long ll;
typedef long double ld;

#define vi vector<int>
#define rep(n) for(ll ii = 0; ii < n; ii++)

using namespace std;

pair<int, int> f(pair<int, int> a)
{
    if (a.first > a.second)
        return {a.second, a.first};
    return a;
}

int main()
{
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> d;
    int a, b, c;
    rep(n)
    {
        cin >> a >> b >> c;
        d.push_back({f({a, b}), c});
        d.push_back({f({a, c}), b});
        d.push_back({f({b, c}), a});
    }
    sort(d.begin(), d.end());
    vector <int> ans = {a, b, c};
    rep(n - 3)
    {
        int p = ans[ii], x = ans[ii + 1], y = ans[ii + 2];
        auto it = lower_bound(d.begin(), d.end(), pair<pair<int, int>, int>(f({x, y}), 0));
        if (it->second == p)
            it++;
        ans.push_back(it->second);
    }
    for (auto e : ans)
        cout << e << " ";
    cout << "\n";
    return 0;
}
