#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt,tune=native")
#pragma GCC target("avx,avx2")

#include "bits/stdc++.h"

typedef long long ll;
typedef long double ld;

#define vi vector<int>
#define rep(n) for(ll ii = 0; ii < n; ii++)

using namespace std;

pair<int, int> f(pair<int, int> a)
{
    if (a.first > a.second)
        return {a.second, a.first};
    return a;
}

//7
//3 7 2
//5 4 6
//7 1 2
//6 4 1
//2 5 3
//5 3 4
//1 6 7

int n;
vector<pair<pair<int, int>, int>> d;

vector<int> solve(vector <int>& ans)
{
    vector<int> r = ans;
    rep(n - 3)
    {
        int p = ans[ii], x = ans[ii + 1], y = ans[ii + 2];
        auto it = lower_bound(d.begin(), d.end(),
                              pair<pair<int, int>, int>(f({x, y}), 0));
        if (it->second == p)
            it++;
        if (it == d.end() || it->first != f(pair<int, int>(x, y)))
        {
            next_permutation(r.begin(), r.end());
            return solve(r);
        }
        ans.push_back(it->second);
    }
    return ans;
}

int main()
{
    cin >> n;
    int a, b, c;
    rep(n)
    {
        cin >> a >> b >> c;
        d.push_back({f({a, b}), c});
        d.push_back({f({a, c}), b});
        d.push_back({f({b, c}), a});
    }
    sort(d.begin(), d.end());
    vector<int> u = {a, b, c};
    sort(u.begin(), u.end());
    vector<int> ans = solve(u);
    for (auto e : ans)
        cout << e << " ";
    cout << "\n";
    return 0;
}
