#pragma optimize( "", on )
#pragma GCC optimize("Ofast")

#include <iostream>
#include <algorithm>
#include <vector>
#include <utility>
using namespace std;
#define int long long
#define PAR pair<int, vector<int>>
#define VI vector<int>
VI sum(VI& a, VI& b) {
	VI res;
	res.resize(max(a.size(), b.size()));
	for (int i = 0; i < a.size(); ++i) {
		res[i] += a[i];
	}
	for (int i = 0; i < b.size(); ++i) {
		res[i] += b[i];
	}
	return res;
}
void clear(VI& v) {
	for (int i = 0; i < v.size(); ++i) {
		v[i] = 0;
	}
}
vector<PAR> snm;
int parent(int a) {
	if (snm[a].first == a) {
		return a;
	}
	return snm[a].first = parent(snm[a].first);
}
void soed(int a, int b) {
	a = parent(a);
	b = parent(b);
	if (a == b) {
		return;
	}
	snm[a].second = sum(snm[a].second, snm[b].second);
	clear(snm[b].second);
	snm[b].first = a;
}
void fri(int a, int b) {
	++(snm[parent(a)].second[b]);
	++(snm[parent(b)].second[a]);
}
int get(int a) {
	return snm[parent(a)].second[a];
}
signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	snm.resize(n);
	for (int i = 0; i < n; ++i) {
		snm[i] = PAR(i, vector<int>(n, 0));
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		fri(a, b);
	}
	for (int i = 0; i < k; ++i) {
		int a, b;
		cin >> a >> b;
		--a; --b;
		soed(a, b);
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		string c;
		cin >> c;
		if (c[0] == '?') {
			int x;
			cin >> x;
			--x;
			cout << get(x) << '\n';
		}
		else {
			int a, b;
			cin >> a >> b;
			--a; --b;
			if (c[0] == 'T') {
				soed(a, b);
			}
			else {
				fri(a, b);
			}
		}
	}
	cout << endl;
	return 0;
}
