#include <iostream>
#include <vector>
#include <map>
using namespace std;

vector<map<int, int>> list;
vector<int> used;

void dfs(int v) {
	cout << v + 1 << ' ';
	used[v] = 1;
	for (auto i : list[v]) {
		if (!used[i.first] && i.second > 1)
			dfs(i.first);
	}
	exit(0);
}


int main()
{
	int n, a, b, c;
	cin >> n;
	list.resize(n);
	used.resize(n, 0);

	for (int i = 0; i < n; ++i) {
		cin >> a >> b >> c;
		list[a - 1][b - 1]++;
		list[b - 1][a - 1]++;
		list[a - 1][c - 1]++;
		list[c - 1][a - 1]++;
		list[b - 1][c - 1]++;
		list[c - 1][b - 1]++;
	}

	dfs(0);
	return 0;
}