#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <map>
#include <vector>
#include <cmath>

int main( void )
{
  long long n, m, s;
  std::vector<long long *> Pays;

  std::cin >> n >> m >> s;
  if (n < 1 || n > 1000 || m < 1 || m > 1000)
  {
	printf("NO");
	return 0;
  }
  if (s < 1 || s > 1e6)
  {
	printf("NO");
	return 0;
  }

  for (int i(0); i < n; i++)
  {
	long long *p = new long long[3];

	std::cin >> p[0] >> p[1] >> p[2];

	if (p[0] < -1e6 || p[0] > 1e6)
	{
	  printf("NO");
	  return 0;
	}
	if (p[1] < 1 || p[2] < p[1] || p[2] > m || p[2] < 1 || p[1] > m)
	{
	  printf("NO");
	  return 0;
	}
	Pays.push_back(p);
  }

  for (long long i(0); i < m; i++)
  {
	long long sum(0), day(0), max = -INFINITY, sum2(0);

	for (long long j(0); j < n; j++)
	  if (Pays[j][1] == i + 1)
		if (max < Pays[j][2])
		  max = Pays[j][2];

	for (long long j(0); j < n; j++)
	  if (Pays[j][2] == max)
		if (Pays[j][0] < 0)
		  sum += Pays[j][0];
		else 
		  sum2 += Pays[j][0];

	if (s + sum + sum2 < 0)
	{
	  std::cout << "YES";
	  return 0;
	}
	else
	  s += sum + sum2;
  }

  std::cout << "NO";

  /*
	unsigned NumOfA, NumOfS, NumOfP(0);
	std::string TrueA;
	std::map<int, std::string> Ans;
	std::vector<int*> Pairs;

	std::cin >> NumOfA;
	if (NumOfA < 1 || NumOfA > 100)
	{
	  std::cout << "0" << std::endl;
	  return 1;
	}
	std::cin >> TrueA;

	if (TrueA.size() != NumOfA)
	{
	  std::cout << "0" << std::endl;
	  return 1;
	}
	std::cin >> NumOfS;
	if (NumOfS < 1 || NumOfS > 100)
	{
	  std::cout << "0" << std::endl;
	  return 1;
	}

	for (int i(0); i < NumOfS; i++)
	{
	  std::cin >> Ans[i];

	  if (Ans[i].size() != NumOfA)
	  {
		std::cout << "0" << std::endl;
		return 1;
	  }

	  for (int j(0); j < Ans[i].size(); j++)
		if (Ans[i][j] == 'A' || Ans[i][j] == 'B' || Ans[i][j] == 'C' || Ans[i][j] == 'D')
		  ;
		else
		{
		  std::cout << "0" << std::endl;
		  return 1;
		}
	}
	
	for (int i(0); i < NumOfS - 1; i++)
	  for (int j(i + 1); j < NumOfS; j++)
	  {
		  int NumOfTrue(0), NumOfFalse(0), NumOfTrueAll(0), NumOfFalseAll(0);

		  for (int k(0); k < NumOfA; k++)
		  {
			if (Ans[i][k] == TrueA[k])
			{
			  if (Ans[i][k] == Ans[j][k])
				NumOfTrue++;
			  NumOfTrueAll++;
			}
			else
			{
			  if (Ans[i][k] == Ans[j][k])
				NumOfFalse++;
			  NumOfFalseAll++;
			}
		  }
		  if ((NumOfTrue * 2 > (NumOfTrueAll)) && (NumOfFalse * 2 > (NumOfFalseAll)))
		  {
			int* P = new int[2];

			P[0] = i;
			P[1] = j;

			NumOfP++;
			Pairs.push_back(P);
		  }
	  }
	std::cout << Pairs.size() << std::endl;
	for (int i(0); i < Pairs.size(); i++)
	  std::cout << Pairs[i][0] + 1 << ' ' << Pairs[i][1] + 1 << std::endl;
  */
	return 0;
}