#include <bits/stdc++.h>
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

bool perm(int l, int r, const vector<int> &A) {
	set<int> S;
	for (int i = l; i <= r; i++) S.insert(A[i]);
	return (int)S.size() == r - l + 1;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int n; cin >> n;
	vector<int> P(n);
	for (int i = 0; i < n; i++) cin >> P[i];
	
	vector<vector<int>> A(n + 2);
	A[1] = { 1 };
	A[2] = { 1, 2, 1 };
	for (int t = 3; t <= n; t++) {
		for (int i = 0; i < min(t - 2, (int)A[t - 1].size()); i++) A[t].push_back(A[t - 1][i]);
		for (int i = t - 2; i < (int)A[t - 1].size(); i++) {
			A[t].push_back(A[t - 1][i]);	
			if (perm(i - (t - 2), i, A[t - 1])) {
				A[t].push_back(t);
				for (int j = i - (t - 2); j <= i; j++) A[t].push_back(A[t - 1][j]);
			}
		}
	}
	
	for (int i = 0; i + n <= (int)A[n].size(); i++) {
		int ok = 1;
		for (int j = 0; j < n; j++) if (P[j] != A[n][i + j]) {
			ok = 0;
			break;
		}
		if (ok) {
			cout << i + 1 << "\n";
			break;
		}
	}
	return 0;
}